#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_CDKEY_GiftCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_CDKEY_GiftCFG> M_CDKEY_GiftCFG::msSingleton(nullptr);

int M_CDKEY_GiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_CDKEY_GiftCFGData* M_CDKEY_GiftCFG::GetData(int GiftId)
{
	auto it = mMapData.find(GiftId);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_CDKEY_GiftCFGData>& M_CDKEY_GiftCFG::GetMapData()
{
	return mMapData;
}

void M_CDKEY_GiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_CDKEY_GiftCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_CDKEY_GiftCFGData data;
		data.mGiftId = element->IntAttribute("GiftId");
		data.mGiftName = element->Attribute("GiftName");
		data.mGold = element->IntAttribute("Gold");
		data.mGem = element->IntAttribute("Gem");
		data.mDragbonBall = element->IntAttribute("DragbonBall");
		{
			const char* Item = element->Attribute("Item");
			std::vector<std::string> vecItem;
			boost::split(vecItem, Item, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItem[i].c_str(), &temp))
				{
					data.mItem.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mGiftId) != mMapData.end())std::cout <<"data refind:" << data.mGiftId << std::endl;
		assert(mMapData.find(data.mGiftId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mGiftId, data));
		element = element->NextSiblingElement();
	}
}

void M_CDKEY_GiftCFG::Load()
{
	Load("../Config/M_CDKEY_GiftCFG.xml");
}

M_CDKEY_GiftCFG* M_CDKEY_GiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_CDKEY_GiftCFG());
	}
	return msSingleton.get();
}
